/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version 1.0
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef BITMAP_STRUCT_H
#define BITMAP_STRUCT_H

#include <Bitmap.h>

/*******************************************************
*   The following is a layout of the structure for 
*   interfaceing with the Bitmap Layer.  The structure
*   returned via GetData() has the following format
*******************************************************/

// Inferno colorspaces
enum ISpace{
   I_NONE,
   I_RGB32,
   I_RGB24,
   I_RGB16,
   I_RGB8,
   I_B_W,
   I_CMYK,
   I_GRAY
};

// possible channels
enum {
   I_CHANNEL_R = 0x01,
   I_CHANNEL_G = 0x02,
   I_CHANNEL_B = 0x04,
   I_CHANNEL_A = 0x08
};

// The meat of this file :)
struct bitmap_layer_info{
   ISpace colorspace;    // the color space of this layer
   uint32 channel;     // the current mask of chanels
   BBitmap *layer_bitmap; // the bitmap
};


#endif
