/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef _DIRECT_HELPER_H
#define _DIRECT_HELPER_H

#include <Bitmap.h>

#define MAX_CHECKER_SIZE 32

// Some built in speed tables for use
// by anyone :)  If you dont want 
// use them you don't have to.
extern uint8 trans_tab[256][256];
extern uint8 trans_inv_tab[256][256];
extern uint8 add_tab[256][256];
extern uint8 sub_tab[256][256];
extern uint8 dist_tab[256][256];
extern uint8 bump_tab[256][256];
extern uint8 lighten_tab[256][256];
extern uint8 darken_tab[256][256];

// Table used for masking the selection
extern uint8 selection_mask[256];

// Inits the trans tables for speed lookups
// Core calls this so you dont have to worky about it.
// You shouldn't call it.
void inittables();

// Clears a bitamp passes in with the given color.
// If filles the entire bounds and respects alpha 
// settings in the color.
void clear_bitmap(BBitmap*,rgb_color);

// Same a clear_bitmap but only uses the area r 
// as the rect
void clear_bitmap_area(BBitmap *img,BRect r,rgb_color c);

// Merges a bitmap dest and src into one bitmap
// and writes the results to dest bitmap. You can
// also spesify 'trans'parancy level for the src
// bitmap to be drawn in. Also you can offset the 
// the src bitmap by a x,y value. The src will be 
// cliped and moved.
// The des bitmap is changed to the result however
// the src bitmap does not change.
void merge(BBitmap *dest,BBitmap *src,uint8 trans = 255,int32 xoff = 0,int32 yoff = 0);

// Draw a checker board on the image useing the
// offset to calculate pattern.
void checker(BBitmap *img,BRect offset);

// Returns whether a point x,y is within the selection. 
// if it is not withing the selection it returns 0 (false)
// if it is part of the selection it returns true.
// We are adding some extra into here thus the uint8
// In the future selection will have soft edges.
// Thus it could be only 100 in the selction
// or if its fully in the selection its 255
uint8 is_in_selection(BBitmap *selection,int32 x,int32 y);

// Takes a bitmap and searches for values that 
// are selected, 255 is selected value.  The
// bitmap must be a Grey8 color space or things
// get ugly
BRect SelectionBounds(BBitmap *selection);

// Inverts the content of a bitmap
// usefull for Selection bitmap.
void invert_bitmap(BBitmap *img);

// Dosen't realy work :P See /etc/rgb.txt on
// your bfs volume if you realy need this
const char* NameForColor(rgb_color c);


#endif

