/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef SCRATCH_VIEW_H
#define SCRATCH_VIEW_H

#include <View.h>

class ScratchView{
public:
   ScratchView(BView *canvas);
   ~ScratchView();
   void StrokeArc(BRect rect,float angle,float span);
   void StrokeArc(BPoint center,float xRadius,float yRadius,float angle,float span);
   void StrokeBezier(BPoint *controlPoints);
   void StrokeEllipse(BRect rect);
   void StrokeEllipse(BPoint center,float xRadius,float yRadius);
   void StrokeLine(BPoint,BPoint);
   void StrokePolygon(BPoint *pointList, int32 numPoints);
   void StrokeRect(BRect rect);
   void StrokeRoundRect(BRect rect,float xRadius,float yRadius);
   void StrokeTriangle(BPoint first,BPoint second,BPoint third);
   void InvertRect(BRect rect);
   
   void StrokeShape(BShape *shape);
   void DrawString(const char *string, BPoint point,BFont font);
private:
   ScratchView();
   ScratchView(const ScratchView&);
   ScratchView& operator=(ScratchView&);
private:
   BView *canvas;
};
#endif
