/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef I_UNITS
#define I_UNITS

#include <SupportDefs.h>

/*******************************************************
*   Some basic info about unit converstions ...
*******************************************************/
enum unit_type{
   PIXEL,
   INCH,
   CM,
   PICA,
   POINT,
   PERCENT
};

#define PIXELS_PER_INCH   72.0
#define PICA_PER_INCH     6.0
#define POINT_PER_INCH    72.0
#define CM_PER_INCH       2.54

/*******************************************************
*   Simple func to do convertions for us :P
*******************************************************/
float convert_unit(float u, unit_type in_type, unit_type out_type = PIXEL);

/*******************************************************
*   Returns a human redable name Long or short (ie: Centimeter/cm)
*******************************************************/
const char* unit_name(unit_type type,bool full);

#endif
