/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef TRANS_OPEN_PANEL_H
#define TRANS_OPEN_PANEL_H

#include <FilePanel.h>
#include <InterfaceKit.h>
#include <String.h>

class BitmapView;
class ImageRefFilter;
class ExpanderButton;

#define OPEN_FILE_PANEL_REFRESH           'rfsh'
#define OPEN_FILE_PANEL_FILTER_ALL        'fall'
#define OPEN_FILE_PANEL_FILTER_ALL_IMAGES 'fali'
#define OPEN_FILE_PANEL_MIME              'mime'

class TranslatorOpenPanel : public BFilePanel, public BHandler {
public:
   TranslatorOpenPanel(BHandler *handler,BMessage *message);
   ~TranslatorOpenPanel();
   virtual void MessageReceived(BMessage*);
   virtual void SelectionChanged();
private:
   void BuildMenu(BMenu*);
private:
   BMenuItem *itemimg;
   BMenuItem *itemall;
   BView *background;
   BView *extra;
   BitmapView *preview;
   bool Expanded;
   ImageRefFilter *IRF;

   BStringView *Iname;
   BStringView *Iwidth;
   BStringView *Iheight;
   BStringView *Idesc;
   
   ExpanderButton *eb;
};
#endif
