/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef TRANSLATORSAVEPANEL_H
#define TRANSLATORSAVEPANEL_H

#include <FilePanel.h>
#include <InterfaceKit.h>
#include <TranslationDefs.h>

#define SAVE_FILE_PANEL_FORMAT 	 'sfpf'
#define SAVE_FILE_PANEL_SETTINGS 'sfps'

class TranslatorMenuItem : public BMenuItem {
public:
   TranslatorMenuItem(const char *name, BMessage *message, translator_id id, uint32 format);
   translator_id id;
   uint32 format;
};

class TranslatorSavePanel : public BFilePanel, public BHandler {
public:
   TranslatorSavePanel(const char *name, BMessenger *target, entry_ref *start_directory,uint32 node_flavors, bool allow_multiple_selection, BMessage *message,BRefFilter *filter = NULL, bool modal = false, bool hide_when_done = true);
   void MessageReceived(BMessage *message);
   TranslatorMenuItem *GetCurrentMenuItem();
   ~TranslatorSavePanel();
private:
   void BuildMenu();
   void TranslatorSettings();
   BWindow *configwindow;
   BPopUpMenu *formatpopupmenu;
   BMenuField *formatmenufield;
   uint32 what;
};

#endif
