/*******************************************************
*   YTabView©
*   
*   File: TTabView.h
*   Description:  A better tab view .. mostly
*   
*   @author  YNOP(ynop@acm.org)
*   @version 1.0
*   @date    May 5 2000
*******************************************************/
/*******************************************************
*   Thanks to the many people who helped out - in 
*   paritcular:
*   jbq (Yap that Be guy) - if you dont know him, why are you useing be?
*   MMI (dont know realy name) that hands out in #bedev (also works at be)
*   Eugenia initial GUI look of Round tabs (I changed them a little :P)
*   Electroly (#bedev) teaching me some debuger stuff :P
*   Michael Nielsen, used CoolCat to write doc, and thanks for all the testing
*******************************************************/
#ifndef Y_TAB_VIEW_H
#define Y_TAB_VIEW_H

#include <String.h>
#include <List.h>

#include <Debug.h>

/******************************************************
*   These are the basics vars that affect how some parts
*   of the tab view work. About the only two that may
*   be usefull are the fixed width and mabey the 
*   Truncate mode. But thats about all
******************************************************/
#define tab_pad 5
#define tab_buf 1
#define tab_fixed_width 75
#define defualt_tab_height 25
#define text_jump 1  // @skip how far the text jumps when its selected
#define TRUNC_MODE B_TRUNCATE_END // Mode can be B_TRUNCATE_END, B_TRUNCATE_SMART  or B_TRUNCATE_BEGINNING

// Some constants that get returned
#define CURRENT_TAB -1
#define TAB_NOT_FOUND -1

// WIDTH_ANY is only for internal use, you should NEVER use it!
enum tab_modes{
  WIDTH_ANY = 0,
  WIDTH_FROM_WIDEST,
  WIDTH_ADAPT_TO_FIT,
  WIDTH_CLIP_TEXT
};

enum tab_orientation{
   TAB_NORTH = 1,
   TAB_EAST,
   TAB_SOUTH,
   TAB_WEST
};



struct tab_item{
   BView *view;
   BString name;
   bool disabled;
};

/*static property_info prop_list[] = {
   { "duck", {B_GET_PROPERTY, B_SET_PROPERTY, 0}, {B_DIRECT_SPECIFIER, B_INDEX_SPECIFIER, 0}, "get or set duck"},
   { "head", {B_GET_PROPERTY, 0}, {B_DIRECT_SPECIFIER, 0}, "get head"},
   { "head", {B_SET_PROPERTY, 0}, {B_DIRECT_SPECIFIER, 0}, "set head"},
   { "feet", {0}, {0}, "can do anything with his orange feet"},
   { 0 } // terminate list
};*/

class YTabView : public BView{
public:
   YTabView(BRect frame,const char *name = NULL, tab_orientation place = TAB_NORTH, tab_modes mode = WIDTH_CLIP_TEXT, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW|B_NAVIGABLE_JUMP|B_FRAME_EVENTS|B_NAVIGABLE);
   YTabView(BMessage *data);
   static BArchivable* Instantiate(BMessage *data);
   virtual status_t Archive(BMessage *data, bool deep = true) const;
   ~YTabView();
   virtual BRect Bounds();
   virtual void Draw(BRect rect);
   virtual void MessageReceived(BMessage *msg); 
   virtual void FrameResized(float w,float h); 
   virtual void MouseDown(BPoint); 
   
   // Scripting does not work yet ....
   status_t GetSupportedSuites(BMessage *msg);
   BHandler* ResolveSpecifier(BMessage *msg, int32 index, BMessage *spec, int32 form, const char *prop);
   
   virtual status_t AddTab(BView *view, const char* label = NULL, int32 loc = CURRENT_TAB);
   virtual status_t RemoveTab(int32 loc = CURRENT_TAB);
   BView* ItemAt(int32 loc = CURRENT_TAB) const;
         
   virtual status_t SelectTab(const int32 loc);
   int32 SelectedTab() const;
   bool IsSelected(int32 loc);
   
   bool IsEnabled(int32 loc = CURRENT_TAB) const;
   status_t SetEnabled(bool enabled = false, int32 loc = CURRENT_TAB);
   
   void SetOrientation(const tab_orientation place);
   tab_orientation GetOrientation() const;
   
   void SetWidthMode(const tab_modes mode);
   tab_modes GetWidthMode() const;
   
   void SetHeight(const float height);
   float GetHeight() const ;
   
   void SetLabelForTab(const int32 loc = CURRENT_TAB,const char *label = NULL);
   const char* GetLabelForTab(int32 loc = CURRENT_TAB) const;
   
   int32 CountTabs() const;
   
   int32 FindTabByName(const char *name) const;
   int32 FindTabByContent(BView *content) const;
   
   // Hooks
   virtual void DrawTab(BRect rect,const tab_item &item,int32 current);
   virtual void onRightClick(int32 loc,BPoint where);
   
private:
   float CalcTabWidth(const tab_item &item,tab_modes mode = WIDTH_ANY);
   void ReCalc(bool force = false);
   void DrawLabel(BRect rect,const tab_item &item,int32 current);
   
private:
   int32 CurrentSelection;
   int32 TabCount;
   tab_orientation TabOrent;
   tab_modes TabMode;
   
   float RowHeight;
   float TabHeight;
   float WidestTab;
   int32 RowCount;
   
   BList HotSpots;
   BList ViewList;
   
protected:
   BFont *TabFont;
};
#endif
