/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  Frans van Nispen (xlr8@tref.nl)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef GRADIENT_H
#define GRADIENT_H
#include <GraphicsDefs.h>
#include "InfernoCommon.h"

#define MAX_SPLITS	20
#define G_SIZE		1024

enum {G_FG = 0, G_BG = 1, G_COLOR = 2};

class Gradient {
public:
	Gradient(InfernoCommon *IC);
	Gradient(const Gradient&,InfernoCommon *IC);
	Gradient(char *file,InfernoCommon *IC);
	~Gradient();
	InfernoCommon *ICommon;
	
	void SetCurrent();						// for external use
	void Save();							// save the gradient
	void Save(char *file);					// save and rename
	rgb_color GetColor(float offset);		// get offset in list
	void Calc();							// calculate the gradient

	char name[255];
	int	count;			// number of splits
	float divider[MAX_SPLITS], split[MAX_SPLITS];
	rgb_color color[MAX_SPLITS];
	rgb_color buffer[G_SIZE+1];				// temp buffer for the colors
	int type[MAX_SPLITS];
};
#endif
