/*******************************************************
*   Inferno©
*   
*   This file may be used under under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@ynop.net)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef BUTTON_TOOL_H
#define BUTTON_TOOL_H

#include "InfernoLayer.h"
#include "InfernoHistory.h"
#include "InfernoTool.h"

class TOOL_SYMBOLS ButtonTool : public InfernoTool {
public:
   ButtonTool(BMessage *pref,InfernoCommon *IC);
   virtual ~ButtonTool();
   virtual void SaveState(BMessage *prefs);
   
   void SetButtons(BBitmap *ActiveUp, BBitmap *ActiveDown, BBitmap *Disabled);
   
   virtual void Select();
   virtual void DeSelect();
   virtual void SetEnabled(bool enable);
   
   virtual void Init(InfernoLayer *Ilayer, ScratchView *Scratch,BBitmap *selection, InfernoHistory *IHist);
   
   virtual void GetSettingsView(BView *v);
   
   
   virtual void AttachedToWindow();
   virtual status_t GetSupportedSuites(BMessage *message);
   virtual BHandler* ResolveSpecifier(BMessage *message,int32 index,BMessage *specifier,int32 what,const char *property);
   virtual void MessageReceived(BMessage *msg);
   
   //virtual status_t Perform(preform_code d,void *arg);
private:
   BPictureButton *PBut;
   BBitmap *states[3];
   
   uint32 _reserved[4];
};
#endif
