/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef FLOATER_ADDON_H
#define FLOATER_ADDON_H

#ifdef BUILDING_I_CORE
#define FLOATER_SYMBOLS _IMPORT
#else
#define FLOATER_SYMBOLS _EXPORT
#endif

#include <Window.h>

#include "InfernoLayer.h"

class InfernoDocument;
class InfernoCommon;

#define FLOATER_API_VER LAYER_API_VER + 002

class FLOATER_SYMBOLS FloaterAddon:public BWindow{
public:
   FloaterAddon(BMessage *prefs,InfernoCommon *IC);
   virtual void Init(InfernoDocument *i);
   virtual ~FloaterAddon();
   virtual void SaveState(BMessage *prefs);
   virtual BView* GetSettingsView(BRect);
   
   void Minimize(bool);
   void FrameMoved(BPoint);
   bool QuitRequested();  
   
   virtual status_t Perform(perform_code d, void *arg);
protected:     
   InfernoDocument *info;
   InfernoCommon *ICommon;
private:
   virtual void _ReservedFloater1();
   virtual void _ReservedFloater2();

   FloaterAddon();
   FloaterAddon(const FloaterAddon&);
   FloaterAddon& operator=(FloaterAddon&);
   
   static int32 _SnapWatcher_Thread_(void *data){
      return ((FloaterAddon*)(data))->SnapWatcher_Thread();
   }
   int32 SnapWatcher_Thread();
private:
   thread_id snapWatcherThread;
   
   uint32 _reserved[4];
};
extern "C" FLOATER_SYMBOLS FloaterAddon *instantiate_addon(BMessage *prefs,InfernoCommon *IC);
#endif
