/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version 1.0
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef CMS_H
#define CMS_H

#include <Message.h>
#include <GraphicsDefs.h>
#include <Bitmap.h>
#include <View.h>

#ifdef BUILDING_I_CORE
#define	CMS_SYMBOLS _IMPORT // @skip
#else
#define	CMS_SYMBOLS _EXPORT // @skip
#endif

#define CMS_API_VER 001 // @skip

class CMS_SYMBOLS InfernoCMS{
public:
   InfernoCMS(BMessage *pref);
   virtual ~InfernoCMS();
   virtual void SaveState(BMessage *pref);
   virtual status_t Transform(BBitmap *bmap, BRect clip) = 0;
   virtual status_t Transform(rgb_color oldcolor, rgb_color *newcolor) = 0;
   virtual BView* GetConfigView();
   virtual status_t Perform(perform_code d, void *arg);
private:
   virtual void _ReservedCMS1();
   virtual void _ReservedCMS2();
   
   InfernoCMS();
   InfernoCMS(const InfernoCMS&);
   InfernoCMS& operator=(InfernoCMS&);
   
   uint32 _reserved[2];
};
extern "C" CMS_SYMBOLS InfernoCMS *instantiate_cms(BMessage*);
#endif
