/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version beta
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef INFERNO_CONVERTER_H
#define INFERNO_CONVERTER_H

#include <Looper.h>

#include "InfernoLayer.h"

#ifdef BUILDING_I_CORE
#define CONVERTER_SYMBOLS _IMPORT
#else
#define CONVERTER_SYMBOLS _EXPORT
#endif

class InfernoDocument;
class InfernoCommon;

#define CONVERTER_API_VER LAYER_API_VER + 002 // @skip

enum{
   I_EXPORTER      = 0x01,
   I_IMPORTER      = 0x02,
   I_IMPORTER_EXPORTER = I_EXPORTER|I_IMPORTER
}; 

class CONVERTER_SYMBOLS InfernoConverter:public BLooper{
public:
   InfernoConverter(BMessage *init,InfernoCommon *ICommon,InfernoDocument *frominfo = NULL,const BBitmap *flatimage = NULL);
   virtual ~InfernoConverter();
   virtual void SaveState(BMessage *prefs);
   void Finalize(InfernoDocument *toinfo = NULL);
   //virtual status_t Perform(perform_code d, void *arg);
protected:
   InfernoCommon *ICommon;
private:
   //virtual void _ReservedConverter1();
   //virtual void _ReservedConverter2();
   
   InfernoConverter();
   InfernoConverter(const InfernoConverter&);
   InfernoConverter& operator=(InfernoConverter&);
   
   uint32 _reserved[2];
};
extern "C" CONVERTER_SYMBOLS InfernoConverter *instantiate_converter(BMessage*,InfernoCommon *,InfernoDocument*,BBitmap*);
#endif


