/*******************************************************
*   Inferno©
*   
*   This file may be used under the license as
*   stated below. For more information about License
*   types see the included LICENSE file. If you did 
*   not recive a copy of that file contact the author.
*   
*   @author  YNOP (ynop@acm.org)
*   @version 1.0
*   @date    Feb 5 2000
*   @license Inferno SDK Code
*******************************************************/
#ifndef INFERNO_TOOL_H
#define INFERNO_TOOL_H

#include <View.h>

#ifdef BUILDING_I_CORE
#define	TOOL_SYMBOLS _IMPORT
#else
#define	TOOL_SYMBOLS _EXPORT
#endif

//#include "InfernoLayer.h"
class InfernoLayer;
class InfernoCommon;
class ScratchView;
class InfernoHistory;

#define TOOL_API_VER LAYER_API_VER+005 // @skip
#define TOOL_SELECT_MESSAGE 'tool' // @skip

class TOOL_SYMBOLS InfernoTool:public BView{
public:
   InfernoTool(BMessage *prefs,InfernoCommon *IC);      
   virtual ~InfernoTool();
   virtual void SaveState(BMessage *prefs);
   
   virtual void Select();
   virtual void DeSelect();
   virtual void SetEnabled(bool enable = true);
   
   virtual void Init(InfernoLayer *Ilay,ScratchView *Scratch,BBitmap *selection, InfernoHistory *IHist);
   
   virtual void IMouseDown(BPoint,uint32 button);
   virtual void IMouseUp(BPoint,uint32 button);
   virtual void IMouseMove(BPoint,uint32 button);
   
   virtual BView* GetConfigView();
   virtual void GetSettingsView(BView *v);
   virtual const BCursor* GetToolCursor();
   
   virtual status_t GetSupportedSuites(BMessage *message);
   virtual BHandler* ResolveSpecifier(BMessage *message,int32 index,BMessage *specifier,int32 what,const char *property);
   
   virtual void MessageReceived(BMessage *msg);
   
   // safty net for ioctrl like expandibility
   virtual status_t Perform(perform_code d, void *arg);
public:
   // these two vars should not ever be touch by you
   int32 BarPosition; 
   char *UniqueID;
protected:
   InfernoLayer *ILay;
   ScratchView *Scratch;
   InfernoCommon *ICommon;
   BBitmap *selection;
   InfernoHistory *IHist;
private:
   virtual void _ReservedTool1();
   virtual void _ReservedTool2();
   virtual void _ReservedTool3();
   virtual void _ReservedTool4();
   
   InfernoTool();
   InfernoTool(const InfernoTool&);
   InfernoTool &operator=(InfernoTool&);
   
   uint32 _reserved[4];
};
extern "C" TOOL_SYMBOLS InfernoTool *instantiate_tool(BMessage *,InfernoCommon *);
#endif

